package repeaterhub;

import java.util.Dictionary;
import java.util.Hashtable;
import org.apache.felix.dm.Component;
import org.opendaylight.controller.forwardingrulesmanager.IForwardingRulesManager;
import org.opendaylight.controller.sal.core.ComponentActivatorAbstractBase;
import org.opendaylight.controller.sal.packet.IDataPacketService;
import org.opendaylight.controller.sal.packet.IListenDataPacket;

public class Activator extends ComponentActivatorAbstractBase {
    @Override
    public void init() {
    }
    @Override
    public void destroy() {
    }
    @Override
    public Object[] getImplementations() {
        Object[] res = {RepeaterHub.class};
        return res;
    }
    @Override
    public void configureInstance(Component c, Object imp, String containerName) {
        if (imp.equals(RepeaterHub.class)) {
            Dictionary<String, String> props = new Hashtable<String, String>();
            props.put("salListenerName", "ListenDataPacket");              
            c.setInterface(new String[] { IListenDataPacket.class.getName() }, props);
            c.add(createContainerServiceDependency(containerName)
                    .setService(IForwardingRulesManager.class)
                    .setCallbacks("setForwardingRulesManager", "unsetForwardingRulesManager")
                    .setRequired(true));
            c.add(createContainerServiceDependency(containerName)
                    .setService(IDataPacketService.class)
                    .setCallbacks("setDataPacketService", "unsetDataPacketService")
                    .setRequired(true));       
        }
    }
}